#!/bin/sh

[ -z "$(fw_printenv bootargs | grep mtdparts)" ] && [ -z "$(fw_printenv mtdparts 2>/dev/null)" ] && exit 0

BOOTARGS=$(fw_printenv -n bootargs 2>/dev/null)

if [ -n "$(echo $BOOTARGS | grep 'mtdparts')" ]; then
    MTDPARTS=$(echo $BOOTARGS | awk -F' ' '{ for (i=1; i<=NF; i++) { str=$i; if (str ~ "mtdparts"){print str} }}')
    BOOTARGS=$(echo $BOOTARGS | sed "s@$MTDPARTS@@")
    MTDPARTS=$(echo $MTDPARTS | sed -r 's/mtdparts=//g')
    if [ -n "$(echo $MTDPARTS | grep 'spi32766')" ]; then
        MTDPARTS=$(echo $MTDPARTS | sed -r 's/spi32766.0/spi0.0/g')
    fi
    fw_setenv mtdparts $MTDPARTS
    fw_setenv bootargs $BOOTARGS
fi

MTDPARTS=$(fw_printenv -n mtdparts 2>/dev/null)
if [ -n "$(echo $MTDPARTS | grep 'spi32766')" ]; then
    MTDPARTS=$(echo $MTDPARTS | sed -r 's/spi32766.0/spi0.0/g')
    fw_setenv mtdparts $MTDPARTS
fi
